// Andreas Bolka, 2010-11-08
//
// To the extent possible under law, Andreas Bolka has waived all copyright and
// related or neighboring rights to this source code. This work is published
// from: Austria.
//
// http://creativecommons.org/publicdomain/zero/1.0/

#include <stdio.h>
#include <string.h>
#include "zlib.h"

#include "reb-host.h"

const char *init_block =
    "REBOL [\n"
        "Title: {Example Zlib extension}\n"
        "Name: zlib\n"
        "Type: extension\n"
    "]\n"
    "export zlib-version: command [{Return the Zlib version.}]\n"
;

RL_LIB *RL;

const char *RX_Init(int opts, RL_LIB *lib) {
    RL = lib;
    return init_block;
}

int RX_Call(int cmd, RXIFRM *frm, void *data) {
    switch (cmd) {
        case 0: {
            // Retrieve the zlib version from the library.
            const char *v = zlibVersion();

            // Copy the above string into a REBOL string!.
            int i;
            REBSER *s = RL_MAKE_STRING(strlen(v), 0);
            for (i = 0; i < strlen(v); ++i)
                RL_SET_CHAR(s, i, v[i]);

            // Return a string! value.
            RXA_SERIES(frm, 1) = s;
            RXA_INDEX(frm, 1) = 0;
            RXA_TYPE(frm, 1) = RXT_STRING;
            return RXR_VALUE;
        }
    }
    return RXR_NO_COMMAND;
}
